Loading...
Searching...
No Matches
wayland::xdg_activation_token_v1_t Class Reference

an exported activation handle More...

`#include <wayland-client-protocol-unstable.hpp>`

Inheritance diagram for wayland::xdg_activation_token_v1_t:
[legend]
Collaboration diagram for wayland::xdg_activation_token_v1_t:
[legend]

## Public Types

enum class | wrapper_type { standard , display , foreign , proxy_wrapper }

## Public Member Functions

void | set_serial (uint32_t serial, seat_t const &seat)
| specifies the seat and serial of the activating event
void | set_app_id (std::string const &app_id)
| specifies the application being activated
void | set_surface (surface_t const &surface)
| specifies the application being activated
void | commit ()
| issues the token request
std::function< void(std::string)> & | on_done ()
| the exported activation token
uint32_t | get_id () const
| Get the id of a proxy object.
std::string | get_class () const
| Get the interface name (class) of a proxy object.
uint32_t | get_version () const
| Get the protocol object version of a proxy object.
wrapper_type | get_wrapper_type () const
| Get the type of a proxy object.
void | set_queue (event_queue_t queue)
| Assign a proxy to an event queue.
wl_proxy * | c_ptr () const
| Get a pointer to the underlying C struct.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
| operator bool () const
| Check whether this wrapper actually wraps an object.
bool | operator== (const proxy_t &right) const
| Check whether two wrappers refer to the same object.
bool | operator!= (const proxy_t &right) const
| Check whether two wrappers refer to different objects.
void | proxy_release ()
| Release the wrapped object (if any), making this an empty wrapper.

## Static Public Attributes

static constexpr std::uint32_t | set_serial_since_version = 1
| Minimum protocol version required for the set_serial function.
static constexpr std::uint32_t | set_app_id_since_version = 1
| Minimum protocol version required for the set_app_id function.
static constexpr std::uint32_t | set_surface_since_version = 1
| Minimum protocol version required for the set_surface function.
static constexpr std::uint32_t | commit_since_version = 1
| Minimum protocol version required for the commit function.

## Detailed Description

an exported activation handle

An object for setting up a token and receiving a token handle that can be passed as an activation token to another client.

The object is created using the xdg_activation_v1.get_activation_token request. This object should then be populated with the app_id, surface and serial information and committed. The compositor shall then issue a done event with the token. In case the request's parameters are invalid, the compositor will provide an invalid token.

Definition at line 6742 of file wayland-client-protocol-unstable.hpp.

## Member Enumeration Documentation

## wrapper_type

enum class wayland::proxy_t::wrapper_type

strong inherited

Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator
standard | C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.
display | C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign

C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper | C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 116 of file wayland-client.hpp.

## Member Function Documentation

## c_ptr()

wl_proxy * wayland::proxy_t::c_ptr | ( |  | ) | const

inherited

Get a pointer to the underlying C struct.

Returns
  The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

## commit()

void xdg_activation_token_v1_t::commit | ( |  | ) |

issues the token request

Requests an activation token based on the different parameters that have been offered through set_serial, set_surface and set_app_id.

Definition at line 8758 of file wayland-client-protocol-unstable.cpp.

## get_class()

std::string wayland::proxy_t::get_class | ( |  | ) | const

inherited

Get the interface name (class) of a proxy object.

Returns
  The interface name of the object associated with the proxy

## get_id()

uint32_t wayland::proxy_t::get_id | ( |  | ) | const

inherited

Get the id of a proxy object.

Returns
  The id the object associated with the proxy

## get_version()

uint32_t wayland::proxy_t::get_version | ( |  | ) | const

inherited

Get the protocol object version of a proxy object.

Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
  The protocol object version of the proxy or 0

## get_wrapper_type()

wrapper_type wayland::proxy_t::get_wrapper_type | ( |  | ) | const

inline inherited

Get the type of a proxy object.

Definition at line 302 of file wayland-client.hpp.

## on_done()

std::function< void(std::string)> & xdg_activation_token_v1_t::on_done | ( |  | ) |

the exported activation token

Parameters

  token | the exported activation token

The 'done' event contains the unique token of this activation request and notifies that the provider is done.

Applications will typically receive the token through the XDG_ACTIVATION_TOKEN environment variable as set by its launcher, and should unset the environment variable right after this request, in order to avoid propagating it to child processes.

Applications implementing the D-Bus interface org.freedesktop.Application should get their token under XDG_ACTIVATION_TOKEN on their platform_data.

Presentation tokens may be transferred across clients through means not described in this protocol.

Definition at line 8764 of file wayland-client-protocol-unstable.cpp.

## operator bool()

wayland::proxy_t::operator bool | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## operator!=()

bool wayland::proxy_t::operator!= | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to different objects.

## operator==()

bool wayland::proxy_t::operator== | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to the same object.

## proxy_has_object()

bool wayland::proxy_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## proxy_release()

void wayland::proxy_t::proxy_release | ( |  | ) |

inherited

Release the wrapped object (if any), making this an empty wrapper.

Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
  foreign_display.cpp.

## set_app_id()

void xdg_activation_token_v1_t::set_app_id | ( | std::string const & | app_id | ) |

specifies the application being activated

Parameters

  app_id | the application id of the client being activated.

The requesting client can specify an app_id to associate the token being created with it.

Must be sent before commit. This information is optional.

Definition at line 8746 of file wayland-client-protocol-unstable.cpp.

## set_queue()

void wayland::proxy_t::set_queue | ( | event_queue_t | queue | ) |

inherited

Assign a proxy to an event queue.

Parameters

  queue | The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
  proxy_wrapper.cpp.

## set_serial()

void xdg_activation_token_v1_t::set_serial | ( | uint32_t | serial,
|  | seat_t const & | seat
| ) |  |

specifies the seat and serial of the activating event

Parameters

  serial | the serial of the event that triggered the activation
  seat | the wl_seat of the event

Provides information about the seat and serial event that requested the token.

Must be sent before commit. This information is optional.

Definition at line 8740 of file wayland-client-protocol-unstable.cpp.

## set_surface()

void xdg_activation_token_v1_t::set_surface | ( | surface_t const & | surface | ) |

specifies the application being activated

Parameters

  surface | the requesting surface

The requesting client can specify a surface to associate the token being created with it.

Must be triggered before commit. This information is optional.

Definition at line 8752 of file wayland-client-protocol-unstable.cpp.

## Member Data Documentation

## commit_since_version

constexpr std::uint32_t wayland::xdg_activation_token_v1_t::commit_since_version = 1

static constexpr

Minimum protocol version required for the commit function.

Definition at line 6821 of file wayland-client-protocol-unstable.hpp.

## set_app_id_since_version

constexpr std::uint32_t wayland::xdg_activation_token_v1_t::set_app_id_since_version = 1

static constexpr

Minimum protocol version required for the set_app_id function.

Definition at line 6794 of file wayland-client-protocol-unstable.hpp.

## set_serial_since_version

constexpr std::uint32_t wayland::xdg_activation_token_v1_t::set_serial_since_version = 1

static constexpr

Minimum protocol version required for the set_serial function.

Definition at line 6779 of file wayland-client-protocol-unstable.hpp.

## set_surface_since_version

constexpr std::uint32_t wayland::xdg_activation_token_v1_t::set_surface_since_version = 1

static constexpr

Minimum protocol version required for the set_surface function.

Definition at line 6809 of file wayland-client-protocol-unstable.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.cpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp